.PRECIOUS: $(OBJDIR)/%.o

SSRCFILES = $(addprefix $(OBJDIR)/,$(notdir $(SRCS)))
OBJS_CC  = $(filter %.o,$(SSRCFILES:.c=.o))
OBJS_CXX = $(filter %.o,$(SSRCFILES:.cpp=.o))
OBJS_RC  = $(filter %.o,$(SSRCFILES:.rc=.o))
OBJS_RES = $(filter %.o,$(SSRCFILES:.res=.o))
OBJS = $(OBJS_CC) $(OBJS_CXX) $(OBJS_RC) $(OBJS_RES)

.PHONY: all build do-build clean tags

build:
	@$(MAKE_SUBDIR)
	@mkdir -p $(OBJDIR)
	@+$(REMAKE) do-build

clean:
	@$(MAKE_SUBDIR)
	rm -fr $(TARGETS) $(OBJDIR) *~

LD ?= $(CC)

ifdef TARGET_BIN
$(TARGET_BIN) : $(OBJS)
	$(LD) -g -o $@ $^ $(LIBS)
endif

ifdef TARGET_LIB
$(TARGET_LIB) : $(OBJS)
	$(AR) crus $@ $^
endif

ifdef TARGET_DLL
$(TARGET_DLL) : $(OBJS)
ifeq ($(OBJS_CXX),)
	$(CC) -shared -o $@ $^ $(LIBS)
else
	$(CXX) -shared -o $@ $^ $(LIBS)
endif
endif

OPTFLAGS ?= -march=i686 -O2

.SUFFIXES:

$(OBJDIR)/%.o: %.c
	$(CC) $(CCFLAGS) $(OPTFLAGS) $(INCLUDES) -c -o $@ $<

$(OBJDIR)/%.o: %.cpp
	$(CXX) $(CXXFLAGS) $(OPTFLAGS) $(INCLUDES) -c -o $@ $<

$(OBJDIR)/%.o: %.rc
	$(WINDRES) $< -o $@

$(OBJDIR)/%.o: %.res
	$(WINDRES) $< -o $@

tags:
	gtags -iv

ifeq ($(MAKECMDGOALS),do-build)
ifdef SRCS
-include $(OBJDIR)/*.d
endif
endif

